/*
 * Application.c
 *
 */

/*---- INCLUDE FILES --------------------------------------------------------------------------------------*/
#include "Application.h"
#include "basictlc.h"

/*---- DEFINES --------------------------------------------------------------------------------------------*/
#define DLL_NAME                        "basictlc_006"
#define SRZ_NAME                        "basictlc_006"
#define MODEL_NAME                      "basictlc"
#define MODEL_GUID                      "24b321fa-a9c7-451e-ba-44-42-ab-07-f4-c5"
#define BUILD_GUID                      "5bed814c-87a6-41fb-91-4c-ef-50-e9-26-e6"
#define TOKEN_GUID                      "no token"
#define MOTOHAWK_VERSION                "MotoHawk 0.8.4_beta11"
#define MATLAB_VERSION                  "MATLAB 7.0"

/*---- TYPEDEF --------------------------------------------------------------------------------------------*/

/*---- FUNCTION PROTOTYPES --------------------------------------------------------------------------------*/

void ApplicationCallback(E_ExecutionEvent in_eEvent);
void OpenApplication(E_OpenEventType open_type);

/*---- CONSTANTS ------------------------------------------------------------------------------------------*/

#pragma ghs startsda
#pragma ghs section rosdata=".constants"

/* Name: SwIdTxt ClassID:TEXT StorageID:CODE Access:RO4+RO3+RO2+RO1 UpdateID:ONCE TextLen:13
   Group:"System | Version" Help:"Software Format ID" */
const uint1 SwIdTxt[13] = DLL_NAME;

/* Name: SwRevisionTxt ClassID:TEXT StorageID:CODE Access:RO4+RO3+RO2+RO1 UpdateID:ONCE TextLen:50 
   Group:"System | Version" Help:"Software Revision ID" */
const uint1 SwRevisionTxt[50] = SRZ_NAME;

/* Name: MotoHawkModelName ClassID:TEXT StorageID:CODE Access:RO4+RO3+RO2+RO1 UpdateID:ONCE TextLen:80
   Group:"System | Version" Help:"Simulink model name used for the MotoHawk build" */
const uint1 MotoHawkModelName[80] = MODEL_NAME;

/* Name: MotoHawkVersionTxt ClassID:TEXT StorageID:CODE Access:RO4+RO3+RO2+RO1 UpdateID:ONCE TextLen:50
   Group:"System | Version" Help:"MotoHawk version used to build the application." */
const uint1 MotoHawkVersionTxt[50] = MOTOHAWK_VERSION;

/* Name: MatlabVersionTxt ClassID:TEXT StorageID:CODE Access:RO4+RO3+RO2+RO1 UpdateID:ONCE TextLen:80
   Group:"System | Version" Help:"MATLAB version used to build the application." */
const uint1 MatlabVersionTxt[80] = MATLAB_VERSION;

/* Name: MotoHawkModelGUID ClassID:TEXT StorageID:CODE Access:RO4+RO3+RO2+RO1 UpdateID:ONCE TextLen:80
   Group:"System | Version" Help:"GUID identifying the MotoHawk model" */
const uint1 MotoHawkModelGUID[80] = MODEL_GUID;

/* Name: MotoHawkBuildGUID ClassID:TEXT StorageID:CODE Access:RO4+RO3+RO2+RO1 UpdateID:ONCE TextLen:80
   Group:"System | Version" Help:"GUID identifying the MotoHawk build session" */
const uint1 MotoHawkBuildGUID[80] = BUILD_GUID;

/* Name: MotoHawkTokenGUID ClassID:TEXT StorageID:CODE Access:RO4+RO3+RO2+RO1 UpdateID:ONCE TextLen:80
   Group:"System | Version" Help:"GUID identifying the MotoTron token inserted during the build.  May be empty if no token was available" */
const uint1 MotoHawkTokenGUID[80] = TOKEN_GUID;

/* Name: table_0_rev CType:uint1 ClassID:VAR StorageID:CODE Access:RO4+RO3+RO2+RO1 TypeID:UINT1 Gain:1 Min:0 
   Max:255 Format:3.0 UpdateID:ONCE Struct:Table0Rev_cu1 Group:"System | Version" Help:"VarDec Table0 Revision Number" */
const uint1 Table0Rev_cu1 = 9.0;

/* Name: table_1_rev CType:uint1 ClassID:VAR StorageID:CODE Access:RO4+RO3+RO2+RO1 TypeID:UINT1 Gain:1 Min:0 
   Max:255 Format:3.0 UpdateID:ONCE Struct:Table1Rev_cu1 Group:"System | Version" Help:"VarDec Table1 Revision Number" */
const uint1 Table1Rev_cu1 = 2;

/* Name: table_2_rev CType:uint1 ClassID:VAR StorageID:CODE Access:RO4+RO3+RO2+RO1 TypeID:UINT1 Gain:1 Min:0 
   Max:255 Format:3.0 UpdateID:ONCE Struct:Table2Rev_cu1 Group:"System | Version" Help:"VarDec Table2 Revision Number" */
const uint1 Table2Rev_cu1 = 1;

/* Name: table_3_rev CType:uint1 ClassID:VAR StorageID:CODE Access:RO4+RO3+RO2+RO1 TypeID:UINT1 Gain:1 Min:0 
   Max:255 Format:3.0 UpdateID:ONCE Struct:Table3Rev_cu1 Group:"System | Version" Help:"VarDec Table3 Revision Number" */
const uint1 Table3Rev_cu1 = 1;

/* Name: table_4_rev CType:uint1 ClassID:VAR StorageID:CODE Access:RO4+RO3+RO2+RO1 TypeID:UINT1 Gain:1 Min:0 
   Max:255 Format:3.0 UpdateID:ONCE Struct:Table4Rev_cu1 Group:"System | Version" Help:"VarDec Table4 Revision Number" */
const uint1 Table4Rev_cu1 = 1;

/* Name: table_5_rev CType:uint1 ClassID:VAR StorageID:CODE Access:RO4+RO3+RO2+RO1 TypeID:UINT1 Gain:1 Min:0 
   Max:255 Format:3.0 UpdateID:ONCE Struct:Table5Rev_cu1 Group:"System | Version" Help:"VarDec Table5 Revision Number" */
const uint1 Table5Rev_cu1 = 1;

/* Name: table_6_rev CType:uint1 ClassID:VAR StorageID:CODE Access:RO4+RO3+RO2+RO1 TypeID:UINT1 Gain:1 Min:0 
   Max:255 Format:3.0 UpdateID:ONCE Struct:Table6Rev_cu1 Group:"System | Version" Help:"VarDec Table6 Revision Number" */
const uint1 Table6Rev_cu1 = 1;

/* Name: table_7_rev CType:uint1 ClassID:VAR StorageID:CODE Access:RO4+RO3+RO2+RO1 TypeID:UINT1 Gain:1 Min:0 
   Max:255 Format:3.0 UpdateID:ONCE Struct:Table7Rev_cu1 Group:"System | Version" Help:"VarDec Table7 Revision Number" */
const uint1 Table7Rev_cu1 = 1;

/* Name: Unused ClassID:VAR StorageID:RAM Access:RO4+NA3+NA2+NA1 TypeID:UINT1 Gain:1 Min:0 Max:255 
   Format:3.0 UpdateID:ONCE Group:"System | Version" Help:"Unused Table Entry" */
const uint1 Unused_ru1 = 0;

#pragma ghs endsda
#pragma ghs section rosdata=default

/*---- CALIBRATION ----------------------------------------------------------------------------------------*/
#pragma ghs section rodata=".cals"

/* Name: CalIdTxt ClassID:TEXT StorageID:FLASH Access:RW4+RW3+RW2+RW1 UpdateID:REMOTE 
   TextLen:33 Group:"System | Version" Help:"Calibration ID" VardecSig:69 */
Calconst uint1 CalIdTxt[54] = SRZ_NAME "_000";

/* Name: PasswordTxt ClassID:TEXT StorageID:FLASH Access:RW4+RW3+RO2+RO1 UpdateID:REMOTE TextLen:33 
   Group:"System | System Config" Help:"Password protection for this calibration" 
   VardecSig:69 */
Calconst uint1 PasswordTxt[33] = "";

/* Name: FriendlyName ClassID:TEXT StorageID:FLASH Access:RW4+RW3+RO2+RO1 UpdateID:REMOTE 
   TextLen:33 Group:"System | System Config" Help:"The device's friendly name." VardecSig:69 */
Calconst uint1 FriendlyName[33] = "PCM";

/* Name: MotoTuneSerialBaudRate ClassID:VAR StorageID:FLASH Access:RW4+RO3+NA2+NA1 UpdateID:REMOTE
   TypeID:UINT4 CType:uint4 Gain:1 Offset:0.0 Exp:1.0 Max:57600 Min:9600 Format:5.0 Mask:FFFFFFFF
   Struct:g_u4KeyBaudRate Help:"The default baud rate that the serial MotoTune protocol will use for connections."
   Group:"System | System Config | Communication Config" */

#pragma ghs section rodata=default

/*---- RAM VARIABLES --------------------------------------------------------------------------------------*/
#pragma ghs startsda
#pragma ghs section sbss=".zerovars"

/* Name: LinkStatus ClassID:VAR StorageID:RAM Access:RO4+RO3+NA2+NA1 TypeID:UINT1 Gain:1 Min:0 Max:255 
   Format:3.0 UpdateID:BACKGND Group:"System | Version" Help:"This is the Status of the Comms link." 
   VardecSig:6C */
uint1 LinkStatus_ru1;

#pragma ghs endsda
#pragma ghs section sbss=default

/*---- APPLICATION STACKS ---------------------------------------------------------------------------------*/

#pragma ghs section bss=".bss_zerovars"
uint1 FgndTimeStack[3072];
#pragma ghs section bss=default

#pragma ghs section bss=default

#pragma ghs section bss=".bss_zerovars"
uint1 BgndStack[2048];
#pragma ghs section bss=default

#pragma ghs section bss=".bss_zerovars"
uint1 IdleStack[1024];
#pragma ghs section bss=default

#pragma ghs section bss=".bss_zerovars"
uint1 InterruptStack[1536];
#pragma ghs section bss=default

/*---- CODE SPACE -----------------------------------------------------------------------------------------*/
#pragma ghs section text=".code"

/*---- LOCAL FUNCTIONS ------------------------------------------------------------------------------------*/
/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
   :: PreStartOS
   :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
void PreStartOS(S_PreStartConfig *config)
{
  /* Configure Stack Sizes */
  config->pIdleStack = (NativeVar_U *) IdleStack;
  config->uIdleStackSize = sizeof(IdleStack);
  config->pFgndTimeStack = (NativeVar_U *) FgndTimeStack;
  config->uFgndTimeStackSize = sizeof(FgndTimeStack);
  config->pBgndStack = (NativeVar_U *) BgndStack;
  config->uBgndStackSize = sizeof(BgndStack);
  config->pInterruptStack = (NativeVar_U *) InterruptStack;
  config->uInterruptStackSize = sizeof(InterruptStack);
  /* No Foreground Angle-Based Stack */
  /* If any angle-based events occur, they will use the FgndTimeStack */
  config->pFgndAngleStack = 0;
  config->uFgndAngleStackSize = 0;

  /* Setup Base OS Event Rates */
  config->uPITCBaseRate = 5000;
  config->uFgndPeriodicBaseRTIMultiple = 1;
  config->uBgndPeriodicBaseRTIMultiple = 10;

  /* For now, use other default settings */
}

/*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
   :: ApplicationCallback
   :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
void ApplicationCallback(E_ExecutionEvent in_eEvent)
{

  {
    extern E_ApplicationInitStatus ApplicationInitStatus;
    extern E_ApplicationStatus ApplicationStatus;
    extern void CheckApplicationStatus(void);

    if (ApplicationInitStatus < APP_INIT_RUN)
    ApplicationStatus = APPLICATION_INIT;

    CheckApplicationStatus();
  }

  switch(in_eEvent)
  {

   case ONE_SECOND_EVENT:
    {
      if (ONE_SECOND_EVENT_RunCnt != 0)
      {
        if (ApplicationStatus == APPLICATION_RUN)
        {
          extern void MotoHawkModelSecondsInUseTick(void);
          MotoHawkModelSecondsInUseTick();
        }
        if (ONE_SECOND_EVENT_RunCnt > 0)
        ONE_SECOND_EVENT_RunCnt--;
      }
    }
    break;

   case FGND_RTI_PERIODIC:
    {
      if (FGND_RTI_PERIODIC_RunCnt != 0)
      {
        if (ApplicationStatus == APPLICATION_RUN)
        {
          extern void Trigger_FGND_RTI_PERIODIC_289p001(void);
          Trigger_FGND_RTI_PERIODIC_289p001();
        }
        if (FGND_RTI_PERIODIC_RunCnt > 0)
        FGND_RTI_PERIODIC_RunCnt--;
      }
    }
    break;

   case BGND_BASE_PERIODIC:
    {
      if (BGND_BASE_PERIODIC_RunCnt != 0)
      {
        if (ApplicationStatus == APPLICATION_RUN)
        {
          extern void Trigger_BGND_BASE_PERIODIC_689p0001(void);
          Trigger_BGND_BASE_PERIODIC_689p0001();
        }
        if (BGND_BASE_PERIODIC_RunCnt > 0)
        BGND_BASE_PERIODIC_RunCnt--;
      }
    }
    break;
  }

  {
    extern E_ApplicationInitStatus ApplicationInitStatus;
    extern E_ApplicationStatus ApplicationStatus;

    if ((ApplicationStatus == APPLICATION_INIT) && (in_eEvent != STARTUP_EVENT))
    {
      StepApplicationStartup();
    }
  }
}

uint32_T RandomNumber_Get()
{
  extern uint2 GetRandomNumber(void);
  return((uint32_T) GetRandomNumber());
}

void ModuleSupport_Reset(void)
{
  DISABLE();
  while(1);
  UNDISABLE();
}

/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
   :: OpenApplication
   :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
void OpenApplication(E_OpenEventType open_type)
{
  /*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
     :: Reset timers
     ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
  {
    ResetFreeRunningCounter64Bits();
  }

  /*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
     :: Setup memory
     ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
  {
    OpenNonVolatile();
  }

  {
    ApplicationStatus = APPLICATION_INIT;
    ApplicationInitStatus = APP_INIT_BEFORE_MODEL;
    prevOSInternalErrorCnt = 0;
    idleCpuSeenNonZero = 0;
  }

  /*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
     :: Initialize Resource Usage, to Pre-Allocate From Heap
     ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
  {
    S_ResourceAllocateFW ResourceAllocateFW;
    NativeError_S sErrorResult;

    ResourceAllocateFW.uValidAttributesMask = USE_ALLOCATE_PWMS |
      USE_ALLOCATE_DISCRETEOUTS | USE_ALLOCATE_FREQINS |
      USE_ALLOCATE_ONESHOTS | USE_ALLOCATE_SWITCHES | USE_ALLOCATE_VARCAMS |
      USE_ALLOCATE_TRANSCOUNT;
    ResourceAllocateFW.uNumPWMsToAllocate = 0;
    ResourceAllocateFW.uNumDiscreteOutsToAllocate = 1;
    ResourceAllocateFW.uNumFreqInsToAllocate = 0;
    ResourceAllocateFW.uNumSwitchesToAllocate = 0;
    ResourceAllocateFW.uNumOneshotsToAllocate = 0;
    ResourceAllocateFW.uNumVarCamsToAllocate = 0;
    ResourceAllocateFW.uNumTransCountToAllocate = 0;

    sErrorResult = AllocateResourcesInFW(&ResourceAllocateFW);
    {
      extern uint16_T resource_allocation;
      if (SUCCESS(sErrorResult)) resource_allocation = 0;
      else resource_allocation = (uint16_T) GetErrorCode(sErrorResult);
    }
  }

  /*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
     :: Setup the event scheduler
     ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
  {
    S_ScheduleCreateResourceAttributes SchedulerCreateAttribObj;
    S_EventCond EventCondObjArr[] = {
      {ONE_SECOND_EVENT, RES_ENABLED},
      {FGND_RTI_PERIODIC, RES_ENABLED},
      {BGND_BASE_PERIODIC, RES_ENABLED},
    };

    SchedulerCreateAttribObj.pfAppCback = ApplicationCallback;
    SchedulerCreateAttribObj.DynamicObj.uValidAttributesMask =
      USE_SCHD_CONDITION;
    SchedulerCreateAttribObj.DynamicObj.EventCondObj.pEventCondObjArr =
      EventCondObjArr;
    SchedulerCreateAttribObj.DynamicObj.EventCondObj.uNumEventsInArray = 3;
    SchedulerCreateAttribObj.uValidAttributesMask = USE_SCHD_DYNAMIC_ON_CREATE |
      USE_SCHD_TASK_MANAGER;
    CreateResource(RES_SCHEDULER, &SchedulerCreateAttribObj,
     BEHAVIOUR_SCHEDULER);
  }

  /*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
     :: Setup the protocol security keys
     ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
  {
    extern void OpenApplicationSecurity(void);
    OpenApplicationSecurity();
  }

  /*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
     :: Install the MotoTron Protocol Archive
     ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
  {
    S_RegisterProtocolArchiveInfo ProtocolArchiveConfigObj;

    /* Use resource scheduler 3 for the MotoTron Protocol Archive */
    ProtocolArchiveConfigObj.uValidAttributesMask = USE_PROTOCOL_SECURITY;
    ProtocolArchiveConfigObj.eSchedulerResource = RES_SCHEDULER_3;
    ProtocolArchiveConfigObj.pfDataRequestCback = NULL;
    ProtocolArchiveConfigObj.pfControlRequestCback = NULL;
    ProtocolArchiveConfigObj.pfDiagnosticFunctionManager = NULL;
    RegisterMotoTronProtocolArchive(&ProtocolArchiveConfigObj);
  }

  /*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
     :: Use the Archive to enable a Link on RS-485 running the Mototron KEY Protocol
     ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
  {
    extern NativeBool MotoSecurity32Function(E_AccessLevel, E_Protocols, uint4
     *);
    S_RegisterCommProtocolInfo ProtocolCommInfoObj;

    ProtocolCommInfoObj.uValidAttributesMask = USE_PROTOCOL_SECURITY;
    ProtocolCommInfoObj.eProtocol = MOTOTRON_KEY_PROTOCOL;
    ProtocolCommInfoObj.eCommResource = RES_RS485;
    ProtocolCommInfoObj.pfSecurityCback = MotoSecurity32Function;
    RegisterCommProtocol(&ProtocolCommInfoObj);
  }

  /* Initialize CAN Bus 1 */
  {
    S_CANCreateResourceAttributes CANCreateObj;
    S_TouCANMessageBufferInfo TouCANMessageDefnObjArr[1];

    /* Initialize CAN Message Queues */
    S_CANQueueDefn QueueDefnObjArr[1];
    CANCreateObj.SWQueueObj.pQueueDefnObjArr = QueueDefnObjArr;
    CANCreateObj.SWQueueObj.uNumQueueDefns = 1;

    /* Queue 0: Buffer 0 */
    QueueDefnObjArr[0].eBufferId = TOUCAN_BUFF0;
    QueueDefnObjArr[0].b1IsForTransmission = TRUE;
    QueueDefnObjArr[0].u2MinQueueDepth = 16;

    /* Setup Baud Rate */
    CANCreateObj.eBaud = CAN_BAUD_250K;

    /* Initialize Message Buffers */
    CANCreateObj.DynamicObj.BufferInfoObj.u1NumBuffersDefined = 1;
    CANCreateObj.DynamicObj.BufferInfoObj.pTouCANBufferObjArr =
      TouCANMessageDefnObjArr;
    {
      /* Transmit Buffer */
      TouCANMessageDefnObjArr[0].BufferDefnObj.uValidAttributesMask =
        USE_CAN_BUFFER_SETTING;
      TouCANMessageDefnObjArr[0].BufferDefnObj.ConfigObj.eFlags =
        CAN_MESSAGE_TRANSMIT;
      TouCANMessageDefnObjArr[0].eBufferID = TOUCAN_BUFF0;
    }

    /* Instantiate CAN Resource */
    CANCreateObj.DynamicObj.CANErrorNotifyObj.pfCback = 0;
    CANCreateObj.DynamicObj.CANErrorNotifyObj.uAppDataToSendWithNotify = 0;
    CANCreateObj.DynamicObj.uValidAttributesMask = USE_CAN_ERROR_NOTIFY |
      USE_CAN_BUFFER;
    CANCreateObj.uValidAttributesMask = USE_CAN_DYNAMIC_ON_CREATE |
      USE_CAN_SW_QUEUES | USE_CAN_BAUD_SETTING;
    CreateResource(RES_CAN1, &CANCreateObj, BEHAVIOUR_TOUCAN);
  }

  /* Register MotoTron CAN Protocol */
  {
    extern NativeBool MotoSecurity32Function(E_AccessLevel, E_Protocols, uint4
     *);
    S_RegisterCANProtocolInfo ProtocolCANInfoObj;
    ProtocolCANInfoObj.eProtocol = MOTOTRON_KEY_PROTOCOL;
    ProtocolCANInfoObj.eCANResource = RES_CAN1;
    ProtocolCANInfoObj.eTXBuffer = TOUCAN_BUFF0;
    ProtocolCANInfoObj.eRXBuffer = TOUCAN_BUFF15;
    ProtocolCANInfoObj.pfProtocolSecurityCback = MotoSecurity32Function;
    ProtocolCANInfoObj.pfAuthoritySecurityCback =
      CanKingAuthoritySecurityFunction;
    ProtocolCANInfoObj.u1MyCity = 0x0B;
    ProtocolCANInfoObj.uValidAttributesMask = USE_PROTOCOL_SECURITY |
      USE_CANKING_SECURITY_AUTHORITY;
    RegisterCANProtocol(&ProtocolCANInfoObj);
  }

  /* Initialize CAN Bus 2 */
  {
    S_CANCreateResourceAttributes CANCreateObj;
    S_TouCANMessageBufferInfo TouCANMessageDefnObjArr[1];

    /* Initialize CAN Message Queues */
    S_CANQueueDefn QueueDefnObjArr[1];
    CANCreateObj.SWQueueObj.pQueueDefnObjArr = QueueDefnObjArr;
    CANCreateObj.SWQueueObj.uNumQueueDefns = 1;

    /* Queue 0: Buffer 0 */
    QueueDefnObjArr[0].eBufferId = TOUCAN_BUFF0;
    QueueDefnObjArr[0].b1IsForTransmission = TRUE;
    QueueDefnObjArr[0].u2MinQueueDepth = 16;

    /* Setup Baud Rate */
    CANCreateObj.eBaud = CAN_BAUD_250K;

    /* Initialize Message Buffers */
    CANCreateObj.DynamicObj.BufferInfoObj.u1NumBuffersDefined = 1;
    CANCreateObj.DynamicObj.BufferInfoObj.pTouCANBufferObjArr =
      TouCANMessageDefnObjArr;
    {
      /* Transmit Buffer */
      TouCANMessageDefnObjArr[0].BufferDefnObj.uValidAttributesMask =
        USE_CAN_BUFFER_SETTING;
      TouCANMessageDefnObjArr[0].BufferDefnObj.ConfigObj.eFlags =
        CAN_MESSAGE_TRANSMIT;
      TouCANMessageDefnObjArr[0].eBufferID = TOUCAN_BUFF0;
    }

    /* Instantiate CAN Resource */
    CANCreateObj.DynamicObj.CANErrorNotifyObj.pfCback = 0;
    CANCreateObj.DynamicObj.CANErrorNotifyObj.uAppDataToSendWithNotify = 0;
    CANCreateObj.DynamicObj.uValidAttributesMask = USE_CAN_ERROR_NOTIFY |
      USE_CAN_BUFFER;
    CANCreateObj.uValidAttributesMask = USE_CAN_DYNAMIC_ON_CREATE |
      USE_CAN_SW_QUEUES | USE_CAN_BAUD_SETTING;
    CreateResource(RES_CAN2, &CANCreateObj, BEHAVIOUR_TOUCAN);
  }

  /* Register MotoTron CAN Protocol */
  {
    extern NativeBool MotoSecurity32Function(E_AccessLevel, E_Protocols, uint4
     *);
    S_RegisterCANProtocolInfo ProtocolCANInfoObj;
    ProtocolCANInfoObj.eProtocol = MOTOTRON_KEY_PROTOCOL;
    ProtocolCANInfoObj.eCANResource = RES_CAN2;
    ProtocolCANInfoObj.eTXBuffer = TOUCAN_BUFF0;
    ProtocolCANInfoObj.eRXBuffer = TOUCAN_BUFF15;
    ProtocolCANInfoObj.pfProtocolSecurityCback = MotoSecurity32Function;
    ProtocolCANInfoObj.pfAuthoritySecurityCback =
      CanKingAuthoritySecurityFunction;
    ProtocolCANInfoObj.u1MyCity = 0x0B;
    ProtocolCANInfoObj.uValidAttributesMask = USE_PROTOCOL_SECURITY |
      USE_CANKING_SECURITY_AUTHORITY;
    RegisterCANProtocol(&ProtocolCANInfoObj);
  }

  {

    ECUP_AnalogInput_Create();
  }

  StepApplicationStartup();
}

/*---- END OF FILE ----------------------------------------------------------------------------------------*/

