#ifndef COMMON_INCLUDE_H
#define COMMON_INCLUDE_H

/*---- INCLUDE FILES --------------------------------------------------------------------------------------*/
#include <stdlib.h>
#include <string.h>
#include <typedefn.h>
#include <rtwtypes.h>

/*---- TYPEDEFS -------------------------------------------------------------------------------------------*/

/* index_T used for prelookup index/fraction values */
typedef uint16_T index_T;

/* reference_T used as a pointer to DataStorage */
typedef void *reference_T;

/* fault_T used as an index to reference a Fault */
typedef uint32_T fault_T;

/* DataStorage uses matrix types for each built-in type */
typedef struct {
  uint32_T numCols;
  real_T data[1];
} matrix_real_T;
typedef struct {
  uint32_T numCols;
  real32_T data[1];
} matrix_real32_T;
typedef struct {
  uint32_T numCols;
  int8_T data[1];
} matrix_int8_T;
typedef struct {
  uint32_T numCols;
  uint8_T data[1];
} matrix_uint8_T;
typedef struct {
  uint32_T numCols;
  int16_T data[1];
} matrix_int16_T;
typedef struct {
  uint32_T numCols;
  uint16_T data[1];
} matrix_uint16_T;
typedef struct {
  uint32_T numCols;
  int32_T data[1];
} matrix_int32_T;
typedef struct {
  uint32_T numCols;
  uint32_T data[1];
} matrix_uint32_T;
typedef struct {
  uint32_T numCols;
  boolean_T data[1];
} matrix_boolean_T;
typedef struct {
  uint32_T numCols;
  reference_T data[1];
} matrix_reference_T;

/*---- CUSTOM TYPEDEF CODE ---------------------------------------------------------------------------------*/

#include <DataStorage_API.h>

/*---- OS INCLUDE FILES --------------------------------------------------------------------------------------*/
#include <interupt.h>
#include <Resource.h>
#include <FrameworkError.h>
#include <SysStat.h>
#include <NativeError.h>
#include <ProtocolAccess.h>
#include <ProtocolArchive.h>
#include <MemFuncs.h>
#include <MemAppFuncs.h>
#include <MotoSecurityItf.h>
#include <MotoTronSpecific.h>

#define RES_NONE                        (-1)

#include "Application.h"

/*---- END OF FILE ----------------------------------------------------------------------------------------*/
#endif                                  /* COMMON_INCLUDE_H */

