#include "Application.h"
#include "basictlc.h"

/*---- DEFINES --------------------------------------------------------------------------------------------*/
#define rtInf                           (100000000000000000.000000)
#define rtMinusInf                      (-100000000000000000.000000)

/*---- CALIBRATION ----------------------------------------------------------------------------------------*/
#pragma ghs section rodata=".cals"

#pragma ghs section rodata=default

/*---- RAM VARIABLES --------------------------------------------------------------------------------------*/
#pragma ghs startsda
#pragma ghs section sbss=".zerovars"

/* Name: ProcessorReboot ClassID:ENUMVAR StorageID:RAM Access:RW4+RW3+RW2+RW1 TypeID:UINT1 CType:Volatile_T Struct:VolatileWork.mh_ProcessorReboot Mask:FFFFFFFF
   Gain:1.0 Offset:0.0 Exp:1.0 Min:0.000000 
   Max:1.000000 Format:1.0 UpdateID:BACKGND Group:"System | Main Power Relay" Help:"Reboots the processor when set."  EnumDec:VarDecEnum_0 */

/* Name: ECUP_Threshold ClassID:VAR StorageID:FLASH Access:RW4+RW3+RW2+RW1 TypeID:UINT2 CType:Constant_T Struct:ConstantWork.mh_ECUP_Threshold Mask:FFFFFFFF
   Gain:1.0 Offset:0.0 Exp:1.0 Min:0.000000 
   Max:1023.000000 Format:5.0 UpdateID:BACKGND Group:"System | Main Power Relay | Main Power Relay Config" Help:"ADC voltage threshold above which ECU is considered powered" Unit:ADC_counts  */

/* Name: MPRD_new ClassID:ENUMVAR StorageID:RAM Access:RW4+RW3+RW2+RW1 TypeID:UINT1 CType:Volatile_T Struct:VolatileWork.mh_MPRD_new Mask:FFFFFFFF
   Gain:1.0 Offset:0.0 Exp:1.0 Min:0.000000 
   Max:1.000000 Format:1.0 UpdateID:BACKGND Group:"System | Main Power Relay | MPRD Override" Help:"Directly Override Main Power Relay" Unit:boolean EnumDec:VarDecEnum_1 */

/* Name: MPRD_ovr ClassID:ENUMVAR StorageID:RAM Access:RW4+RW3+RW2+RW1 TypeID:UINT1 CType:Volatile_T Struct:VolatileWork.mh_MPRD_ovr Mask:FFFFFFFF
   Gain:1.0 Offset:0.0 Exp:1.0 Min:0.000000 
   Max:1.000000 Format:1.0 UpdateID:BACKGND Group:"System | Main Power Relay | MPRD Override" Help:""  EnumDec:VarDecEnum_2 */

/* Name: RestoreNVFactoryDefaults ClassID:ENUMVAR StorageID:RAM Access:RW4+RW3+RW2+RW1 TypeID:UINT1 CType:Volatile_T Struct:VolatileWork.mh_RestoreNVFactoryDefaults Mask:FFFFFFFF
   Gain:1.0 Offset:0.0 Exp:1.0 Min:0.000000 
   Max:1.000000 Format:1.0 UpdateID:BACKGND Group:"System | NonVolatile Storage" Help:"Restores NonVolatile Memory to Factory Defaults"  EnumDec:VarDecEnum_3 */

/* Name: StoreNV ClassID:ENUMVAR StorageID:RAM Access:RW4+RW3+RW2+RW1 TypeID:UINT1 CType:Volatile_T Struct:VolatileWork.mh_StoreNV Mask:FFFFFFFF
   Gain:1.0 Offset:0.0 Exp:1.0 Min:0.000000 
   Max:1.000000 Format:1.0 UpdateID:BACKGND Group:"System | NonVolatile Storage" Help:"Stores RAM-Shadowed memory to serial EEPROM"  EnumDec:VarDecEnum_4 */

/* Name: MPRD ClassID:ENUMVAR StorageID:RAM Access:RO4+RO3+RO2+RO1 TypeID:UINT1 CType:Volatile_T Struct:VolatileWork.mh_MPRD Mask:FFFFFFFF
   Gain:1.0 Offset:0.0 Exp:1.0 Min:0.000000 
   Max:1.000000 Format:1.0 UpdateID:BACKGND Group:"System | Main Power Relay" Help:"Indicates whether the main power relay is active"  EnumDec:VarDecEnum_5 */

/* Name: MPRD_KeepAlive ClassID:ENUMVAR StorageID:RAM Access:RW4+RW3+RW2+RW1 TypeID:UINT1 CType:Volatile_T Struct:VolatileWork.mh_MPRD_KeepAlive Mask:FFFFFFFF
   Gain:1.0 Offset:0.0 Exp:1.0 Min:0.000000 
   Max:1.000000 Format:1.0 UpdateID:BACKGND Group:"System | Main Power Relay" Help:"When enabled, keeps the MPRD output on and keeps the processor alive"  EnumDec:VarDecEnum_6 */

/* Name: dout_create_MPRD ClassID:ENUMVAR StorageID:RAM Access:RO4+RO3+RO2+RO1 TypeID:UINT2
   CType:E_NativeFWError Struct:dout_create_MPRD Mask:FFFFFFFF EnumDec:E_NativeFWError
   UpdateID:BACKGND Group:"System | Debug | Resources | DiscreteOut" Help:"Debug Variable" */
uint16_T dout_create_MPRD = 7;

/* Name: ain_create_ECUP ClassID:ENUMVAR StorageID:RAM Access:RO4+RO3+RO2+RO1 TypeID:UINT2
   CType:E_NativeFWError Struct:ain_create_ECUP Mask:FFFFFFFF EnumDec:E_NativeFWError
   UpdateID:BACKGND Group:"System | Debug | Resources | AnalogIn" Help:"Debug Variable" */
uint16_T ain_create_ECUP = 7;

/* Name: ain_read_ECUP ClassID:ENUMVAR StorageID:RAM Access:RO4+RO3+RO2+RO1 TypeID:UINT2
   CType:E_NativeFWError Struct:ain_read_ECUP Mask:FFFFFFFF EnumDec:E_NativeFWError
   UpdateID:BACKGND Group:"System | Debug | Resources | AnalogIn" Help:"Debug Variable" */
uint16_T ain_read_ECUP = 7;

/* Name: resource_allocation ClassID:ENUMVAR StorageID:RAM Access:RO4+RO3+RO2+RO1 TypeID:UINT2
   CType:E_NativeFWError Struct:resource_allocation Mask:FFFFFFFF EnumDec:E_NativeFWError
   UpdateID:BACKGND Group:"System | Debug | Resources | Other" Help:"Debug Variable" */
uint16_T resource_allocation = 7;

#pragma ghs endsda
#pragma ghs section sbss=default

/*---- END OF FILE ----------------------------------------------------------------------------------------*/

