#---------------------------------------------------------
# v2.0.1 
# 
# Copyright (c) 2002, New Eagle Software, LLC, All 
# Rights Reserved
#
# For information on this or other Chip Support Packages, 
# please visit www.neweagle.net.
#
# New Eagle Software, LLC (734) 822-7710
#
#-------------------------------------------------------%/
#
# File    : basictlc.mk   
#
# 	This makefile attempts to conform to the guidelines specified in the
# 	IEEE Std 1003.2-1992 (POSIX) standard. It is designed to be used
#       with GNU Make (gmake) which is located in matlabroot/rtw/bin/win32.
#
# 	Note that this template is automatically customized by the Real-Time
#	Workshop build procedure to create "<model>.mk"
#
#       file that contains 'rtwgensettings.BuildDirSuffix' see grt.tlc
#------------------------ Macros read by make_rtw ------------------------------
#
# The following macros are read by the Real-Time Workshop build procedure:
#
#  MAKECMD         - This is the command used to invoke the make utility
#  HOST            - What platform this template makefile is targeted for
#                    (i.e. PC or UNIX)
#  BUILD           - Invoke make from the Real-Time Workshop build procedure
#                    (yes/no)?
#  SYS_TARGET_FILE - Name of system target file.

MAKECMD         = "%MATLAB%\rtw\bin\win32\gmake"
HOST            = PC
BUILD           = yes
SYS_TARGET_FILE = motohawk_ert_rtw.tlc

#---------------------- Tokens expanded by make_rtw ----------------------------
#
# The following tokens, when wrapped with "|>" and "|<" are expanded by the
# Real-Time Workshop build procedure.
#
#  MODEL_NAME      - Name of the Simulink block diagram
#  MODEL_MODULES   - Any additional generated source modules
#  MAKEFILE_NAME   - Name of makefile created from template makefile <model>.mk
#  MATLAB_ROOT     - Path to were MATLAB is installed.
#  MATLAB_BIN      - Path to MATLAB executable.
#  S_FUNCTIONS     - List of S-functions.
#  S_FUNCTIONS_LIB - List of S-functions libraries to link. 
#  SOLVER          - Solver source file name
#  NUMST           - Number of sample times
#  TID01EQ         - yes (1) or no (0): Are sampling rates of continuous task
#                    (tid=0) and 1st discrete task equal.
#  NCSTATES        - Number of continuous states
#  BUILDARGS       - Options passed in at the command line.
#  MULTITASKING    - yes (1) or no (0): Is solver mode multitasking
#  EXT_MODE        - yes (1) or no (0): Build for external mode


MODEL           = basictlc
MODULES         = AppMonitor.c Application.c ApplicationSecurity.c CodeCoverage.c Constant.c MotoHawk_IO.c NonVolatile.c Trigger_BGND_BASE_PERIODIC_689p0001.c Trigger_FGND_RTI_PERIODIC_289p001.c VarDecs.c Volatile.c basictlc_Foreground.c 
MAKEFILE        = basictlc.mk
MATLAB_ROOT     = C:\MATLAB7
S_FUNCTIONS     = 
S_FUNCTIONS_LIB = 
SOLVER          = 
NUMST           = 1
TID01EQ         = 0
NCSTATES        = 0
COMPUTER        = PCWIN
BUILDARGS       = ENABLE_BUILD=1 ADD_MDL_NAME_TO_GLOBALS=1 INCLUDE_MDL_TERMINATE_FCN=1 COMBINE_OUTPUT_UPDATE_FCNS=1 EXTMODE_STATIC_ALLOC_SIZE=1000000 MODELLIB=basictlclib.lib SHARED_SRC= SHARED_SRC_DIR= SHARED_BIN_DIR= MODELREF_LINK_LIBS= SHARED_LIB= RELATIVE_PATH_TO_ANCHOR=.. MODELREF_TARGET_TYPE=NONE
MULTITASKING    = 0
GENERATE_ASAP2	= 0

#-------------------- Parameters from motohawk_make_rtw ------------------------
# ENABLE_BUILD

#-------------------------- Directories and Files ------------------------------
TARGET =	.\Target\$(MODEL)
BUILD_SCRIPT =	build.bat

#----------------------------- Source Files ------------------------------------

APP_SRC =	$(MODEL).c \
		$(MODULES) \
    		$(S_FUNCTIONS) \
    		$(SOLVER) \
            	$(EXT_SRC)

export		# make all variables available to sub-makes

#--------------------------------- Rules ---------------------------------------

.PHONY:	BAD_TARGET_OPTION

###  Primary Target  ###
TARGET_UX =	$(subst \,/,$(TARGET))
.PHONY: $(TARGET_UX).srz
$(TARGET_UX).srz:
	@if exist rt_nonfinite.c @echo rt_nonfinite.c					>> $(MODEL)_DEV.bld
	@if exist rt_nonfinite.c @echo C						>> $(MODEL)_DEV.bld
	for %f in ($(foreach f,$(subst /,\,$(APP_SRC)),$f C)) do @echo %f		>> $(MODEL)_DEV.bld
	@if exist rt_nonfinite.c @echo rt_nonfinite.c					>> $(MODEL)_PROD.bld
	@if exist rt_nonfinite.c @echo C						>> $(MODEL)_PROD.bld
	for %f in ($(foreach f,$(subst /,\,$(APP_SRC)),$f C)) do @echo %f		>> $(MODEL)_PROD.bld
	@if exist rt_nonfinite.c @echo rt_nonfinite.c					>> $(MODEL)_Component.bld
	@if exist rt_nonfinite.c @echo C						>> $(MODEL)_Component.bld
	for %f in ($(foreach f,$(subst /,\,$(APP_SRC)),$f C)) do @echo %f		>> $(MODEL)_Component.bld
	@.\setup_files.bat
ifeq ($(ENABLE_BUILD),1)
	@.\build.bat
else
	@echo ### Created Code and Build Scripts.  Ready to Build ###
endif


# EOF: basictlc.mk

